#include<iostream>
using namespace std;

class Target
{
	public:
		virtual void ProcessRequest()=0;
};

class AdapterClient
{
	private:
		Target* target;
	public:
		AdapterClient(Target* target)
		{
			this->target = target;
		}
		void doItTheClientsWay()
		{
			target->ProcessRequest();
		}
};

class Adaptee 
{
	public:
		void doItThisWay()
		{
			cout << "I did it this way" << endl;
		}
};

class Adapter : public Target
{
	private :
		Adaptee* adaptee;
	public :
		Adapter(Adaptee* adaptee)
		{
			this->adaptee = adaptee;
		}

		void ProcessRequest()
		{
			adaptee->doItThisWay();
		}
};

int main()
{
	Adaptee* adaptee = new Adaptee();
	Target* adapter = new Adapter(adaptee);
	AdapterClient adapterClient = AdapterClient(adapter);
	adapterClient.doItTheClientsWay();
}