#include<iostream>
using namespace std;

class Memento
{
private:
	int state;

public:
	Memento(int state)
	{
		this->state = state;
	}

	int getState()
	{
		return state;
	}
};

class Originator
{
private:
	int state; // this can be an object

public:
	Memento createMemento()
	{
		return Memento(state);
	}

	void setMemento(Memento memento)
	{
		this->state = memento.getState();
	}

	bool operator==(const Originator& otherOriginator)
	{
		return this->state == otherOriginator.state;
	}

	void setState(int state)
	{
		this->state = state;
	}
};

// this is also the Caretaker
int main() 
{
	Originator originator;
	originator.setState(101);
	Memento memento = originator.createMemento();
	Originator newOriginator;
	newOriginator.setMemento(memento);
	if(originator == newOriginator)
	{
		cout<<"They are the same "; 
	}
	else
	{
		cout<<"They are not the same "; 
	}
}